#cython: language_level=3

from .capi.obidms       cimport OBIDMS_p
from .capi.obidmscolumn cimport OBIDMS_column_p
from .capi.obitypes     cimport obiversion_t, OBIType_t, index_t


cdef class OBIDMS_column

            
cdef class OBIDMS:

    cdef OBIDMS_p pointer
    cdef str dms_name
    
    cpdef dict list(self)
    cpdef close(self)
    cpdef OBIDMS_column open_column(self,
                                    str column_name,
                                    bint create=*, 
                                    bint clone=*, bint clone_data=*,
                                    obiversion_t version_number=*, 
                                    OBIType_t data_type=*,
                                    index_t nb_lines=*, 
                                    index_t nb_elements_per_line=*, 
                                    list elements_names=*,
                                    str array_name=*)


cdef class OBIDMS_column:

    cdef OBIDMS_column_p    pointer
    cdef OBIDMS             dms
    cdef str                data_type   # TODO keep as OBIType_t? both?
    cdef str                dms_name
    cdef str                column_name
    cdef index_t             nb_elements_per_line
    cdef list               elements_names

#    cpdef object get_item(self, index_t line_nb, str element_name)                  TODO can't declare because not the same in all subclasses
#    cpdef        set_item(self, index_t line_nb, str element_name, object value)    TODO can't declare because object value
    cpdef list    get_elements_names(self)
    cpdef str     get_data_type(self)
    cpdef index_t get_nb_lines_used(self)
    cpdef str     get_creation_date(self)
    cpdef         close(self)

