#cython: language_level=3

from .capi.obitypes cimport obichar_t, index_t
from ._obidms       cimport OBIDMS_column


cdef class OBIDMS_column_char(OBIDMS_column):
    cpdef object get_line(self, index_t line_nb)
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_char_writable(OBIDMS_column_char):     
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_char_multi_elts(OBIDMS_column_char):
    cpdef object get_item(self, index_t line_nb, str element_name)
    cpdef object get_line(self, index_t line_nb)
    cpdef set_item(self, index_t line_nb, str element_name, bytes value)
    cpdef set_line(self, index_t line_nb, object values)

cdef class OBIDMS_column_char_multi_elts_writable(OBIDMS_column_char_multi_elts):
    cpdef set_item(self, index_t line_nb, str element_name, bytes value)
    cpdef set_line(self, index_t line_nb, object values)
    cpdef close(self)
