#cython: language_level=3

from .capi.obitypes cimport obifloat_t, index_t
from ._obidms       cimport OBIDMS_column


cdef class OBIDMS_column_float(OBIDMS_column):
    cpdef object get_line(self, index_t line_nb)
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_float_writable(OBIDMS_column_float):     
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_float_multi_elts(OBIDMS_column_float):
    cpdef object get_item(self, index_t line_nb, str element_name)
    cpdef object get_line(self, index_t line_nb)
    cpdef set_item(self, index_t line_nb, str element_name, obifloat_t value)
    cpdef set_line(self, index_t line_nb, object values)

cdef class OBIDMS_column_float_multi_elts_writable(OBIDMS_column_float_multi_elts):
    cpdef set_item(self, index_t line_nb, str element_name, obifloat_t value)
    cpdef set_line(self, index_t line_nb, object values)
    cpdef close(self)
