#cython: language_level=3

from .capi.obitypes cimport index_t
from ._obidms       cimport OBIDMS_column


cdef class OBIDMS_column_str(OBIDMS_column):
    cpdef object get_line(self, index_t line_nb)
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_str_writable(OBIDMS_column_str):     
    cpdef set_line(self, index_t line_nb, object value)
    cpdef close(self)

cdef class OBIDMS_column_str_multi_elts(OBIDMS_column_str):
    cpdef object get_item(self, index_t line_nb, str element_name)
    cpdef object get_line(self, index_t line_nb)
    cpdef set_item(self, index_t line_nb, str element_name, str value)
    cpdef set_line(self, index_t line_nb, object values)

cdef class OBIDMS_column_str_multi_elts_writable(OBIDMS_column_str_multi_elts):
    cpdef set_item(self, index_t line_nb, str element_name, str value)
    cpdef set_line(self, index_t line_nb, object values)
    cpdef close(self)
